﻿Imports Charmed.Sample.Models
Imports System.Linq
Imports System.Threading.Tasks

Namespace Charmed.Sample.ViewModels
	Public MustInherit Class FeedItemViewModel
		Inherits ViewModelBase(Of FeedItem)
		Private ReadOnly storage As IStorage
		Protected ReadOnly secondaryPinner As ISecondaryPinner

		Public Sub New(ByVal serializer As ISerializer, ByVal storage As IStorage, ByVal secondaryPinner As ISecondaryPinner)
			MyBase.New(serializer)
			Me.storage = storage
			Me.secondaryPinner = secondaryPinner
		End Sub

		Public Overrides Sub LoadState(ByVal navigationParameter As FeedItem, ByVal pageState As Dictionary(Of String, Object))
			Me.FeedItem = navigationParameter
		End Sub

		Protected async Function SavePinnedFeedItem() As Task
            Dim pinnedFeedItems As List(Of FeedItem) = Await Me.storage.LoadAsync(Of List(Of FeedItem))(Constants.PinnedFeedItemsKey)

			If pinnedFeedItems Is Nothing Then
                pinnedFeedItems = New List(Of FeedItem)
			End If

            pinnedFeedItems.Add(feedItemVar)
            Await Me.storage.SaveAsync(Constants.PinnedFeedItemsKey, pinnedFeedItems)
        End Function

        Protected Async Function RemovePinnedFeedItem() As Task
            Dim pinnedFeedItems As List(Of FeedItem) = Await Me.storage.LoadAsync(Of List(Of FeedItem))(Constants.PinnedFeedItemsKey)

            If pinnedFeedItems IsNot Nothing Then
                Dim pinnedFeedItem As FeedItem = pinnedFeedItems.FirstOrDefault(Function(fi) fi.Id = Me.FeedItem.Id)
                If pinnedFeedItem IsNot Nothing Then
                    pinnedFeedItems.Remove(pinnedFeedItem)
                End If

                Await Me.storage.SaveAsync(Constants.PinnedFeedItemsKey, pinnedFeedItems)
            End If
        End Function

        Private feedItemVar As FeedItem
        Public Property FeedItem As FeedItem
            Get
                Return Me.feedItemVar
            End Get
            Set(ByVal value As FeedItem)
                Me.SetProperty(Me.feedItemVar, value)
            End Set
        End Property

        Private isFeedItemPinnedVar As Boolean
        Public Property IsFeedItemPinned As Boolean
            Get
                Return Me.isFeedItemPinnedVar
            End Get
            Set(ByVal value As Boolean)
                Me.SetProperty(Me.isFeedItemPinnedVar, value)
            End Set
        End Property
	End Class
End Namespace
