﻿Imports Charmed.Messaging
Imports Charmed.Sample.Messages
Imports Charmed.Sample.Models
Imports System.Collections.ObjectModel
Imports System.Linq

Namespace Charmed.Sample.ViewModels
	Public NotInheritable Class SettingsViewModel
		Inherits ViewModelBase
		Private ReadOnly settings As ISettings
		Private ReadOnly messageBus As IMessageBus

		Public Sub New(ByVal settings As ISettings, ByVal messageBus As IMessageBus)
			Me.settings = settings
			Me.messageBus = messageBus

            Me.Feeds = New ObservableCollection(Of String)

            Dim feedData() As String = Nothing
            Dim feed As String = String.Empty
			If Me.settings.TryGetValue(Of String())(Constants.FeedsKey, feedData) Then
				For Each feed In feedData
					Me.Feeds.Add(feed)
				Next feed
			End If
		End Sub

		Public Sub AddFeed()
			Me.Feeds.Add(Me.NewFeed)
			Me.NewFeed = String.Empty

			SaveFeeds()
		End Sub

		Public Sub RemoveFeed(ByVal feed As String)
			Me.Feeds.Remove(feed)

            SaveFeeds()
		End Sub

		Private Sub SaveFeeds()
            Me.settings.AddOrUpdate(Constants.FeedsKey, Me.Feeds.ToArray)

            Me.messageBus.Publish(Of FeedsChangedMessage)(New FeedsChangedMessage)
		End Sub

        Private FeedsVar As ObservableCollection(Of String)
        Public Property Feeds As ObservableCollection(Of String)
            Get
                Return FeedsVar
            End Get
            Private Set(ByVal value As ObservableCollection(Of String))
                FeedsVar = value
            End Set
        End Property

        Private newFeedVar As String = String.Empty
        Public Property NewFeed As String
            Get
                Return Me.newFeedVar
            End Get
            Set(ByVal value As String)
                Me.SetProperty(Me.newFeedVar, value)
            End Set
        End Property
	End Class
End Namespace
